#ifndef FLAT_MATRIX_H
#define FLAT_MATRIX_H

#include <stdint.h>

#include "Event_Desc.h"
#include "Collector.h"
#include "Shared_Cache.h"
#include "Wrapped_Symbols.h"

#include "Sample_Grid.h"
#include "Timer.h"

enum
{
	FLAT_GRID_TIME,
	FLAT_GRID_HITS,
	FLAT_GRID_SIZE,
	FLAT_GRID_COUNT
};

static const char * const flat_grid_types_names[FLAT_GRID_COUNT] =
{
	"time",
	"hits",
	"size"
};


struct Flat_Matrix
{
	struct Sample_Grid mpi_grids[T_MPI_COUNT][FLAT_GRID_COUNT];
	struct Sample_Grid posix_grids[T_POSIX_COUNT][FLAT_GRID_COUNT];
};

int  Flat_Matrix_init_coll( struct Collector * coll );
int  Flat_Matrix_release_coll( struct Collector * coll );
void Flat_Matrix_push_event(struct MALP_Trace_Event *, void *);
int  Flat_Matrix_reduce( struct Collector * coll );
int  Flat_Matrix_accumulate( struct Collector * coll );

void Flat_Matrix_init(struct Collector *coll, uint64_t partition_id);


#endif /* FLAT_MATRIX_H */
