#ifndef POSIX_PROFILE_H
#define POSIX_PROFILE_H

#include <stdint.h>

#include "Event_Desc.h"
#include "Collector.h"
#include "Shared_Cache.h"
#include "Wrapped_Symbols.h"
#include "Hash_Table.h"

struct POSIX_Profile_acc
{
	/* Its a bit redundant but saves some 
	 * allocation complexity for a few KB */

	uint64_t associated_tid;
	
	uint64_t hits[T_POSIX_COUNT];
	uint64_t time[T_POSIX_COUNT];
	uint64_t size[T_POSIX_COUNT];

};


#define POSIX_PROF_COLL_AVOID 2
struct POSIX_Profile_acc_cell
{
	struct Hash_Table_Internal _____;
	struct POSIX_Profile_acc accs[POSIX_PROF_COLL_AVOID];
};

struct POSIX_Profile
{
	struct POSIX_Profile_acc global_acc;
	struct Hash_Table per_stream_profiles;
};



int  POSIX_Profile_init_coll( struct Collector * coll );
int  POSIX_Profile_release_coll( struct Collector * coll );
void POSIX_Profile_push_event(struct MALP_Trace_Event *, void *);
int  POSIX_Profile_reduce( struct Collector * coll );
int  POSIX_Profile_accumulate( struct Collector * coll );

void POSIX_Profile_init(struct Collector *coll, uint64_t partition_id);


#endif
