#include "Printer.h"

#include "MPI_Events.h"

#include "Meta_Data_Handler.h"
#include "Shared_Cache.h"
#include "Timer.h"

int  Printer_init_coll( struct Collector * coll )
{
	return 0;
}


int  Printer_release_coll( struct Collector * coll )
{
	return 0;
}



void Printer_push_event(struct MALP_Trace_Event *event, void *pcoll)
{

	printf("%lu Event from %ld type %s(%d)\n", event->timestamp, event->tid, MALP_Trace_event_type_names[event->type], event->type );
	
	if( event->type == MALP_EVENT_WRAPPED )
	{
		struct Wrapped_Event *we = &event->event.wrapped_event;
		printf("==> %s\n", Wrapped_symbol_names[we->type]);
	}
	
	if( event->type == MALP_EVENT_MAP )
	{
		struct MAP_Event *me = &event->event.map;
		printf("MAP [%d, %d] %g %lld\n",  me->plugin_id,  me->metric_id, me->dvalue, me->ulivalue );
	}
	
	
	
}

int  Printer_reduce( struct Collector * coll )
{
	return 0;
}





int  Printer_accumulate( struct Collector * coll )
{
	return 0;
}




void Printer_init(struct Collector *coll, uint64_t partition_id)
{
		
	Collector_init( coll, MALP_EVENT_ANY,
					partition_id,
					"Printer",
					Printer_init_coll,
					Printer_release_coll,
					Printer_push_event,
					Printer_reduce,
					Printer_accumulate );
	
}
