#ifndef RANK_MATRIX_H
#define RANK_MATRIX_H

#include <stdint.h>

#include "Event_Desc.h"
#include "Collector.h"
#include "Wrapped_Symbols.h"
#include "Array.h"


struct Rank_Matrix
{
	struct Array ** mpi;
	struct Array ** posix;
	
	uint64_t size;
};



int  Rank_Matrix_init_coll( struct Collector * coll );


int  Rank_Matrix_release_coll( struct Collector * coll );
void Rank_Matrix_push_event(struct MALP_Trace_Event *, void *);
int  Rank_Matrix_reduce( struct Collector * coll );
int  Rank_Matrix_accumulate( struct Collector * coll );

void Rank_Matrix_init(struct Collector *coll, uint64_t partition_id);


#endif /* RANK_MATRIX_H */
