#ifndef TIME_MATRIX_H
#define TIME_MATRIX_H

#include <stdint.h>

#include "Event_Desc.h"
#include "Collector.h"
#include "Shared_Cache.h"
#include "Wrapped_Symbols.h"

#include "Sample_Grid.h"
#include "Timer.h"

enum
{
	GRID_TIME,
	GRID_HITS,
	GRID_SIZE,
	GRID_COUNT
};

static const char * const grid_types_names[GRID_COUNT] =
{
	"time",
	"hits",
	"size"
};


struct Time_Matrix
{
	struct Sample_Grid mpi_grids[T_MPI_COUNT][GRID_COUNT];
	struct Sample_Grid posix_grids[T_POSIX_COUNT][GRID_COUNT];
};




int  Time_Matrix_init_coll( struct Collector * coll );
int  Time_Matrix_release_coll( struct Collector * coll );
void Time_Matrix_push_event(struct MALP_Trace_Event *, void *);
int  Time_Matrix_reduce( struct Collector * coll );
int  Time_Matrix_accumulate( struct Collector * coll );

void Time_Matrix_init(struct Collector *coll, uint64_t partition_id);


#endif
