#ifndef REPORT_H
#define REPORT_H

#include <stdint.h>

#include "Chained_List.h"
#include "Collector.h"

/* Modules */
#include "Collectors/MPI_Profile.h"
#include "Collectors/POSIX_Profile.h"
#include "Collectors/Topology.h"
#include "Collectors/Time_Matrix.h"
#include "Collectors/Flat_Matrix.h"
#include "Collectors/Printer.h"
#include "Collectors/MALP_OTF2.h"
#include "Collectors/Rank_Matrix.h"

struct Report
{
	struct Chained_List collectors;
};


int Report_init( struct Report *cll );
void Report_release( struct Report *cll );

int Report_register( struct Report *cll, struct Collector *cl );

int Report_init_coll( struct Report *cll );
int Report_reduce( struct Report *cll );
int Report_accumulate( struct Report *cll );


int Report_populate( struct Report *cll, uint64_t partition_id );



#endif
