#ifndef SAMPLE_GRID_H
#define SAMPLE_GRID_H

#include <stdint.h>

#include "jsonCache.h"


struct Sample_Grid
{
	double **grid;
	
	double min;
	double max;
	
	double qx;
	
	uint64_t grid_size_x, slot_count;
		
	int has_data;
	
};


void Sample_Grid_init( struct Sample_Grid *g , uint64_t time_slices, uint64_t slots );
void Sample_Grid_release( struct Sample_Grid *g );
void Sample_Grid_flatten( struct Sample_Grid *g, int multiplicity );

void Sample_Grid_reduce( struct Sample_Grid *g );

void Sample_Grid_dump_text( struct Sample_Grid *g, char *dest );
json_t * Sample_Grid_dump_JSON( struct Sample_Grid *g );

double Sample_Grid_get( struct Sample_Grid *g ,  unsigned int slot, double offset );
void Sample_Grid_accumulate( struct Sample_Grid *g ,  unsigned int slot, double offset, double value );
void Sample_Grid_scale( struct Sample_Grid *g ,double offset );

void Sample_Grid_get_min_max( struct Sample_Grid *g , double *min, double *max );


static inline double Sample_Grid_get_duration( struct Sample_Grid *g )
{
	return g->grid_size_x * g->qx;
}

#endif /* SAMPLE_GRID_H */
