/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#include "CRC64.h"


#define CRC64REV     0xC96C5795D7870F42ULL

uint64_t crc_table[256];

void MALP_Trace_crc64_init()
{
	uint64_t i = 0;
	int j = 0;

	for (i = 0; i < 256; i++) {
		crc_table[i] = i;
		for (j = 0; j < 8; j++) {
			crc_table[i] = (crc_table[i] & 1)?((crc_table[i] >> 1) ^ CRC64REV) : ( crc_table[i] >> 1 );
		}
	}
}


