/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jbbesnard@paratools.fr                     # */
/* #                                                                      # */
/* ######################################################################## */
#ifndef MAP_EVENT_H
#define MAP_EVENT_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>

/** Datatype associated with the metric */
typedef enum
{
	MAP_METRIC_NONE,	/** Default not set */
	MAP_METRIC_UINT64,	/** Caries a 64bit unsigned int */
	MAP_METRIC_DOUBLE,	/** Caries a double */
	MAP_METRIC_COUNT	/** Number of types */
}MAP_Metric_type;

/** Convert a \ref MAP_Metric_type to an human readable format */
static const char * const MAP_Metric_type_name[MAP_METRIC_COUNT] =
{
	"none",
	"uint64_t",
	"double"
};

/** Event used to carry a MAP plugin event */
struct MAP_Event
{
	int plugin_id;				/** Id of the plugin (as seen form the \ref MAP_Plugin_array */
	int metric_id;				/** Id of the \ref MAP_Metric as seen from the \ref MAP_Plugin */
	MAP_Metric_type type;		/** Type of the Metric (choosing between uint64_t and double) */
	double dvalue;				/** Double for this sample */
	uint64_t ulivalue;			/** UINT64_T for this sample */
};


#ifdef __cplusplus
}
#endif

#endif /* MAP_EVENT_H */
