/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */

#ifndef MPI_EVENTS_DEF
#define MPI_EVENTS_DEF

#include <stdint.h>


#define T_MPI_ENUM(a) T_##a
#define T_MPI_NAME(a) #a

typedef enum
{
<MALPW>
MALPW_WNAMECASE_UP( T_MPI_ENUM );
    ,
</MALPW>
    T_MPI_COUNT
} MPI_Event_type;


static const char * const MPI_Event_names[T_MPI_COUNT] =
{
<MALPW>
MALPW_WNAME( T_MPI_NAME );
    ,
</MALPW>
};

/**
 * @ingroup Data_Model_
 * @brief Struct defining a MPI event data. 
 * 
 * This data depends on the MPI call...
 */
struct MPI_Event
{
    MPI_Event_type type;    /**< @brief The MPI event type */
    int source;             /**< @brief The source arg (if present on current MPI call)  */
    int dest;               /**< @brief The destination arg (if present on current MPI call) */
    int tag;                /**< @brief The tag arg (if present on current MPI call)*/
    uint64_t size;          /**< @brief The size arg (if present on current MPI call) */
    uint64_t count;         /**< @brief Tha count arg (if present on current MPI call) */
    uint64_t datatype;      /**< @brief The type arg (if present on current MPI call) */
    uint64_t comm;          /**< @brief The comm arg (if present on current MPI call) */
};




#endif /* MPI_EVENTS_DEF */
