/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
#ifndef OTF_EVENT_H
#define OTF_EVENT_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>

typedef enum
{
	OTF_EVENT_NONE,
	OTF_EVENT_ENTER,
	OTF_EVENT_LEAVE
}OTF_Event_type;

typedef enum
{
	OTF_EVENT_OTHER,
	OTF_EVENT_MPI,
	OTF_EVENT_POSIX
}OTF_Event_category;

struct OTF_Event
{
	OTF_Event_type type;
	OTF_Event_category category;
	
	int64_t str_id;
	
	uint64_t src_tid;
	uint64_t dest_tid;
	uint64_t comm_id;
};


#ifdef __cplusplus
}
#endif

#endif /* OTF_EVENT_H */
