/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */

#include "Trace_Comm.h"

#include <stdio.h>
#include <stdlib.h>

#include "VMPI.h"

MPI_Comm __trace_comm;


void Trace_Comm_init()
{
	if( PMPI_Comm_dup(VMPI_Get_partition_comm(), &__trace_comm) != MPI_SUCCESS )
	{
		printf( "Error creating trace communicator\n");
		abort();
	}
}

void Trace_Comm_release()
{
	PMPI_Comm_free(&__trace_comm);
}
