
/* ############################ MALP License ############################## */
/* # Fri Jan 18 14:00:00 CET 2013                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - BESNARD Jean-Baptiste jean-baptiste.besnard@cea.fr               # */
/* #                                                                      # */
/* ######################################################################## */
/*
 * DEPS
 */

var ph = require('userver').pageHandler;
var cache = require('nsc');
var catalog = module.require("malp_catalog").catalog;

/*
 * MAIN FUNCTIONS
 */

var args = process.argv.splice(2);

for( i=0; i < args.length; i++)
{
	console.log("---> " + args[i]);
}

/* Register the trace passed in argument as a canditate for load in the index */
if( 1 <= args.length )
{
	args[0] = args[0].trim();
	
	if( process.env["PROCESS_ORIG_DIR"] &&  args[0][0] != "/" )
		args[0] = process.env["PROCESS_ORIG_DIR"] + "/" + args[0].trim();
	
	catalog.loadFromArgs(args[0]);
}

function head(page, GET,  POST, FILES, res)
{
	res.write("<link href=\"/css/style.css\" rel=\"stylesheet\" type=\"text/css\" />");
	res.write("<title>" + page.pageHandler.sitename + " - " + page.title + "</title>");
}

function header(page, GET,  POST, FILES, res)
{
	res.write("<table class='title'><tr><td ><img src=\"/img/malp_logo_w.png\" width=\"150px\" /></td><td></td>");
	res.write("<td></td></tr><tr><td></td><td width=100% style='text-align:center;vertical-align:middle'><h2>" + page.pageHandler.sitename + "</h2></td>");
	res.write("<td></td></tr>");
	
	if( catalog.current_app != undefined )
	{
		res.write("<tr><td></td><td><h2><div id='current_title'>"+ catalog.current_app.app + " - " +  catalog.current_app.testcase +" @ " + catalog.current_app.size + "</div></h2></td></tr>");
	}
	else
	{
		res.write("<tr><td></td><td><h2><div id='current_title'>No profile loaded</div></h2></td></tr>");
	}
	
	
	res.write("</table>");
}

function footer(page, GET,  POST, FILES, res)
{
	res.write("<table>");
	res.write("<tr>");
	res.write("<td>");
		res.write("<a href='http://www.cea.fr/english-portal'><img align='center' width='100px' src='/img/CEA.jpg' /></a>");
	res.write("</td>");
	res.write("<td width=100% style='text-align:center;vertical-align:middle'>");
		res.write("<h2>MALP is a profiling tool originally co-developped ");
		res.write("by the CEA and the University of Versailles Saint-Quentin (UVSQ)<br> now distributed under CECILL (LGPL compatible) licence</h2>");
	res.write("</td>");
	res.write("<td>");
	res.write("<a href='http://www.uvsq.fr/'><img align='center' width='200px' src='/img/uvsq.jpg' /></a>");
	res.write("</td>");
	res.write("</tr>");
	res.write("</table>");

}

pageHandler =  new ph();
pageHandler.siteName("Multi-Application Online Profiling");

//Setup static resources
pageHandler.staticResource( "/img", process.env["MALP_SERVER_HOME"] + "/res/img" );
pageHandler.staticResource( "/css", process.env["MALP_SERVER_HOME"] + "/res/css" );
pageHandler.staticResource( "/scripts", process.env["MALP_SERVER_HOME"] + "/res/scripts" );
//pageHandler.setAuth();

//Overide renderers
pageHandler.head = head;
pageHandler.header = header;
pageHandler.footer = footer;

pageHandler.loadTemplates( process.env["MALP_SERVER_HOME"] + "/res/templates", 1 );

cache.setAuth("toto");
cache.listen();

var port = 0;

if( process.env["MALP_PORT"] )
	port = process.env["MALP_PORT"];


pageHandler.listen( port );


