var cache = require('nsc');
var catalog = module.require("malp_catalog").catalog;
var getTop = require("malp_rendering").getTop;
var LoadTrace =  module.require("malp_catalog").LoadTrace;

<page uri="/" title="Index" desc="This is the index"/>


<view uri="genwinlist" raw="true">

<server>
	var view_list = [
		{ title : "Execution Breakdown" , 
		  uri : "/profile/breakdown?body_only=1" ,
		  desc : "This view presents the global balancing between MPI calls and Computations time in your applications.",
		  more : ""
		},
		{ title : "Profile Overview" ,
		  uri : "/profile/summary?body_only=1" ,
		  desc : "This view presents the global profile of your application make sure that MPI calls are not dominating the run.",
		  more : ""
		},	
		{ title : "Time Breakdown over Functions" , 
		  uri : "/perrank/functions?body_only=1",
		  desc : "This section provides insight over the balancing of individual functions over the run.",
		  more : ""
		}
	];
	
	/* Gen MPI matrix */
	
	var topMPI = getTop(3, "MPI")
	
	var i;
	
	for( i = 0 ; i < topMPI.length ; i++ )
	{
		view_list.push( { title : "Time Matrix for "  + topMPI[i] + " (ranked #" + (i+1) + ")",
						  uri : "/timematrix/genall?f=" + topMPI[i] + "&body_only=1" ,
						  desc : "",
						  more : ""
						} );
	}

	/* Gen rank matrix */

	for( i = 0 ; i < topMPI.length ; i++ )
	{
		view_list.push( { title : "Rank Matrix for "  + topMPI[i] + " (ranked #" + (i+1) + ")",
						  uri : "/rankmatrix/genall?f=" + topMPI[i] + "&body_only=1" ,
						  desc : "",
						  more : ""
						} );
	}	
	
	/* Gen topology views */
	var current_prof = catalog.getProfile();

	if( !current_prof )
	{
		res.write("<h1>No profile loaded</h1>");
		return;
	}

	var collector = current_prof["Topology"];

	if( !collector )
		return;

	var i;

	for( e in collector )
	{
		if( e == "name" )
			continue;
		
		view_list.push( { title : "MPI Topology for "  + e,
				  uri : "/networktopo/render?t="+ e +"&body_only=1" ,
				  desc : "This view present the topology for " + e + " in terms of hits, time and total size",
				  more : ""
				} );
	}
	
	
	res.end( JSON.stringify( view_list ) );
</server>

</view>



<body>
<script src='/scripts/jquery.js'></script>
<script src='/scripts/jquery.jqplot.js'></script>
<script src='/scripts/jqplot.pieRenderer.js'></script>
<script src='/scripts/jqplot.highlighter.js'></script>
<script src='/scripts/jqplot.highlighter.js'></script>
<link rel="stylesheet" type="text/css" href="/css/jquery.jqplot.css">
<script type="text/javascript" src="/scripts/jquery.js"></script>

<server>
	if( catalog.loadFromArgs() != "" )
	{
		LoadTrace( res, catalog.loadFromArgs(), true );
		catalog.loadFromArgs("");
		return;
	}
	
	var current_prof = catalog.getProfile();
	
	if( !current_prof )
	{
</server>
		<h1>No profile loaded</h1>
		<p>Please generate a profile using the MALP intrumentation <strong>mpirun -np 64 malp APP [APP_ARGS] : -np 16 malp_an</strong></p>
<server>		
		return;
	}
</server>

<table width="100%">

	<tr>
		<td></td>
		<td width='auto' style='text-align:center;vertical-align:middle'>
			<div id="title"></div>
		</td>
		<td></td>
	</tr>
	<tr>
		<td  id="left" style='text-align:center;vertical-align:middle'>
			<img src="/img/l.png">
		</td>
		<td>
			<div id="content" class="container"></div>
		</td>
		<td id="right" style='text-align:center;vertical-align:middle'>
			<img src="/img/r.png">
		</td>
	</tr>
	<tr>
		<td></td>
		<td width='auto' style='text-align:center;vertical-align:middle'>
			<div id="desc"></div>
		</td>
		<td></td>
	</tr>
</table>


<script>

var current_view = 0;

var view_list = [];

function next_view()
{
	current_view++;
	
	if( current_view == view_list.length )
		current_view = 0;
}

function prev_view()
{
	current_view--;
	
	if( current_view == -1 )
		current_view = view_list.length - 1;
	
}


function load_content()
{
		$("#content").empty().hide();
		$("#title").empty().hide();
		$("#desc").empty().hide();
		
		if( view_list[current_view].uri == "" )
			return;
			
		$("#title").html( "<h1>" + view_list[current_view].title + "</h1>" ).fadeIn(400);
		$("#desc").html( view_list[current_view].desc ).fadeIn(400);
		
		$.ajax({url: view_list[current_view].uri})
		.done(function( data ) {
				$("#content").html( data ).slideDown(400);
				
			  });
			  
}



$(document).ready( function()
{
	$.getJSON('/genwinlist', function(data)
	{
		view_list = data;
	
		load_content();
		
		$("#left").click( function() {
			prev_view();
			load_content();
		});

		$("#right").click( function() {
			next_view();
			load_content();
			
		});
	
	});
});
	

</script>


</body>

