var cache = require('nsc'); 
var prof = require("malp_rendering").profile;
var getTop = require("malp_rendering").getTop;
var catalog = module.require("malp_catalog").catalog;

<page uri="/mpiprof" parent="/profile" title="MPI Profile" desc="This modules displays the MPI profile either per rank or NOT" />


<view uri="summary">
	<script src='/scripts/jquery.js'></script>
	<script src='/scripts/jquery.jqplot.js'></script>
	<script src='/scripts/jqplot.pieRenderer.js'></script>
	<script src='/scripts/jqplot.highlighter.js'></script>
	<script src='/scripts/jqplot.highlighter.js'></script>
	<link rel="stylesheet" type="text/css" href="/css/jquery.jqplot.css">

	<server>
		var current_prof = catalog.getProfile();

		if( !current_prof )
		{
			res.write("<h1>No profile loaded</h1>");
			return;
		}
		
		var collector = current_prof["MPI_Profile"];
		var profile  = new prof( res, collector );
	</server>

	<h1>MPI Profile summary</h1>

	<p>Note that values are relative to MPI function calls only</p>

	<server>
		profile.pie_chart_array(collector.profile);
	</server>
</view>


<view uri="profile">
	<server>
		var current_prof = catalog.getProfile();

		if( !current_prof )
		{
			res.write("<h1>No profile loaded</h1>");
			return;
		}
		
		var collector = current_prof["MPI_Profile"];
		var profile  = new prof( res, collector );
	</server>

	<h1>Global MPI Profile</h1>

	<server>
		profile.render_global();
	</server>

</view>

<view uri="gettop" raw="true">
	<server>
		res.end(JSON.stringify(getTop(3, "MPI")));
	</server>

</view>

<view uri="perrank">
	<server>
		var current_prof = catalog.getProfile();

		if( !current_prof )
		{
			res.write("<h1>No profile loaded</h1>");
			return;
		}
		
		var collector = current_prof["MPI_Profile"];
		var profile  = new prof( res, collector );
	</server>

	<h1>Per Rank MPI Profile</h1>

	<server>
		profile.render_per_stream()
	</server>
	</div>
</view>

<body>

<server>
	var current_prof = catalog.getProfile();

	if( !current_prof )
	{
		res.write("<h1>No profile loaded</h1>");
		return;
	}
</server>
	<script type="text/javascript" src="/scripts/jquery.js"></script>

	<div id="summary"></div>
	<div id="profile"></div>
	<br>
	<button id="perrankbutton">Toogle per Rank Profile...</button>
	<div id="perrank"></div>

	<script type="text/javascript">
	$(document).ready( function()
	{

		$("#summary").hide();
		$("#profile").hide();
		$("#perrank").hide();
			  
		$.ajax({url: "./summary?body_only=1"}).done(function( data ) {
				$("#summary").html( data ).slideDown(1500);
			  });
			  
		$.ajax({url: "./profile?body_only=1"}).done(function( data ) {
				$("#profile").html( data ).slideDown(1500);
			  });

		var per_rank_loaded = 0;

		$("#perrankbutton").click( function() {
			
			if( !per_rank_loaded )
			{
				$.ajax({url: "./perrank?body_only=1"}).done(function( data ) {
					$("#perrank").html( data );
					per_rank_loaded = 1;
				  });
		    }
			  
			$("#perrank").slideToggle(1500);
		});
	});
	</script>

</body>







 
