var nsc = require('nsc');

<page uri="/pirange" parent="/pi" title="Parametric" />


<body>
	

	<script src='/scripts/jquery.js'></script>
	<script type="text/javascript" src="/scripts/d3.js"></script>
	<link rel="stylesheet" type="text/css" href="/css/nv.d3.css"/>
	<script type="text/javascript" src="/scripts/nv.d3.js"></script>

	<h1>Pi Interpolation Parametric Study</h1>


	<h2>A closer Value of Pi</h2>
	
	Actual:<br>
	<div id="actualpi" style="font-size : 30px"></div><br>
	Computed:<br>
	<div id="computedpi" style="font-size : 30px"></div><br>
	Error:<br>
	<div id="error" style="font-size : 30px"></div>
	
	<h2>PI Computation Results</h2>

	<div id="result" style="width : 100%; height: 200px;"><svg></svg></div>
	
	<h2>Numerical Error</h2>

	<div id="errorp" style="width : 100%; height: 200px;"><svg></svg></div>

	<h2>Number of Digit Errors</h2>
	
	<div id="error" style="width : 100%; height: 200px;"><svg></svg></div>
		
	<h2>Computation Time</h2>
	
	<div id="time" style="width : 100%; height: 200px;"><svg></svg></div>
		
	<h2>Interpolation Values</h2>

	<table id="data" class="malptable" style="font-size : 30px">
		<tr>
			<td>Points</td>
			<td>Time</td>
			<td>Errors</td>
			<td>Value</td>
			<td>Numerical Error</td>
		</tr>
	</table>
	
	<script type="text/javascript">
		var point_values = [];
		var last_ts = new Date().getTime();
	
	
	
		/*These lines are all chart setup.  Pick and choose which chart features you want to utilize. */
		function renderError() {
			var chart = nv.models.lineChart()
			.margin({left: 100})
			.xScale( d3.scale.log() )
			.useInteractiveGuideline(true)  
			.transitionDuration(350) 
			.showLegend(true)    
			.showYAxis(true)       
			.showXAxis(true)  
			;


	
			chart.xAxis     //Chart x-axis settings
			.axisLabel('Number of Points')
			.tickFormat(d3.format('.02e')).rotateLabels(-45);

			chart.yAxis     //Chart y-axis settings
			.axisLabel('Error in Digits')
			.tickFormat(d3.format(',.02f'));

			var dat = [];
			
			for( var i = 0 ; i < point_values.length ; i++ )
			{
				dat.push( { "x" : point_values[i].p , "y" : point_values[i].e } );
			}

			var serie = [ {
						  values: dat,
						  key: 'Digit Error',
						  color: '#FF0000'
						 } ];

			d3.select('#error svg')   
			.datum(serie)    
			.call(chart); 

			//Update the chart when window resizes.
			nv.utils.windowResize(function() { chart.update() });
			return chart;
		}
		

	
		function renderResult() {
			var chart = nv.models.lineChart()
			.margin({left: 100})
			.xScale( d3.scale.log() )
			.yScale( d3.scale.log() )
			.useInteractiveGuideline(true)  
			.transitionDuration(350) 
			.showLegend(true)    
			.showYAxis(true)       
			.showXAxis(true)  
			;


	
			chart.xAxis     //Chart x-axis settings
			.axisLabel('Number of Points')
			.tickFormat(d3.format('.02e')).rotateLabels(-45);

			chart.yAxis     //Chart y-axis settings
			.tickFormat(d3.format(',.10f'));

			var dat = [];
			
			for( var i = 0 ; i < point_values.length ; i++ )
			{
				dat.push( { "x" : point_values[i].p , "y" : point_values[i].v } );
			}

			var serie = [ {
						  values: dat,
						  key: 'Interpolated Pi',
						  color: '#0000FF'
						 } ];

			d3.select('#result svg')   
			.datum(serie)    
			.call(chart); 

			//Update the chart when window resizes.
			nv.utils.windowResize(function() { chart.update() });
			return chart;
		}
	
		function renderTime() {
			var chart = nv.models.lineChart()
			.margin({left: 100})
			.xScale( d3.scale.log() )
			.useInteractiveGuideline(true)  
			.transitionDuration(350) 
			.showLegend(true)    
			.showYAxis(true)       
			.showXAxis(true)  
			;


	
			chart.xAxis     //Chart x-axis settings
			.axisLabel('Number of Points')
			.tickFormat(d3.format('.02e')).rotateLabels(-45);

			chart.yAxis     //Chart y-axis settings
			.axisLabel('Time in Seconds')
			.tickFormat(d3.format(',.03f'));

			var dat = [];
			
			for( var i = 0 ; i < point_values.length ; i++ )
			{
				dat.push( { "x" : point_values[i].p , "y" : point_values[i].t } );
			}

			var serie = [ {
						  values: dat,
						  key: 'Computation Time',
						  color: '#00FF00'
						 } ];

			d3.select('#time svg')   
			.datum(serie)    
			.call(chart); 

			//Update the chart when window resizes.
			nv.utils.windowResize(function() { chart.update() });
			return chart;
		}
		

	
		function renderNumError() {
			var chart = nv.models.lineChart()
			.margin({left: 150})
			.xScale( d3.scale.log() )
			.useInteractiveGuideline(true)  
			.transitionDuration(350) 
			.showLegend(true)    
			.showYAxis(true)       
			.showXAxis(true)  
			;


	
			chart.xAxis     //Chart x-axis settings
			.axisLabel('Number of Points')
			.tickFormat(d3.format('.02e')).rotateLabels(-45);

			chart.yAxis     //Chart y-axis settings
			.tickFormat(d3.format(',.02e'));

			var dat = [];
			
			for( var i = 0 ; i < point_values.length ; i++ )
			{
				dat.push( { "x" : point_values[i].p , "y" : point_values[i].d } );
			}

			var serie = [ {
						  values: dat,
						  key: 'Numerical Error',
						  color: '#000000'
						 } ];

			d3.select('#errorp svg')   
			.datum(serie)    
			.call(chart); 

			//Update the chart when window resizes.
			nv.utils.windowResize(function() { chart.update() });
			return chart;
		}
		

	
	
	
	
	
		var pi = 0.0;
		var points = 10;
	    var actualpi = "3.14159265358979323846264338327950288419716939";
	
		function renderpi( data, miss )
		{
			data = data + "";

			var html = "";

			for( var i = 0 ; i < data.length; i++ )
			{
				var canditate =  data.substring( i , i + 1);
				var actual =  actualpi.substring( i , i + 1);
				
				if( canditate == actual )
				{
					html += "<font color='green'>" + canditate + "</font>"
				}
				else
				{
					if( miss )
					{
						html += "<font color='red'>" + actual + "</font>"
					}
					else
					{
						html += "<font color='red'>" + canditate + "</font>"
					}
				}
			}
			
			if( miss )
			{
				for( var i = data.length; i < actualpi.length ; i++ )
				{
					var actual =  actualpi.substring( i , i + 1);
					html += "<font color='grey'>" + actual + "</font>"
				}
			}
			
			
			return html;
		}
	
		function errorspi( data )
		{
			data = data + "";

			var i;
			var html = "";
	
	        var errors = 0;		
	
			for( i = 0 ; i < data.length; i++ )
			{
				var canditate =  data.substring( i , i + 1);
				var actual =  actualpi.substring( i , i + 1);
				
				if( canditate != actual )
				{
					errors++;
				}
			}
			
			
			return errors;
		}
		
		function pushpi( data )
		{
			var now = new Date().getTime();
			var dt = (now - last_ts) / 1000.0;
			last_ts = now;
			
			var nerror = 3.14159265358979 - parseFloat(data);
			point_values.push( { "p" : points, "e" : errorspi(data), "v" : data , "t" : dt, "d" : nerror} );
			
			var pts = parseFloat( points ).toExponential();
			
			$("#data").append("<tr><td>" + pts + "</td><td>" + dt + "</td><td>" + errorspi(data) + "</td><td>"+ renderpi(data) + "</td><td>"+ nerror + "</td></tr>");
			
			renderError();
			renderResult();
			renderTime();
			renderNumError();
			
			$("#actualpi").html( renderpi( data, 1 ) );
			$("#computedpi").html( renderpi( data ) );
			$("#error").html( 3.14159265358979 - parseFloat(data) );
			
			points *= 2;
			
			$.ajax({
			  url: "setpoints?p=" + points,
			  context: document.body
			});
		}
	
		$(document).ready( function()
		{
			$.ajax({
			  url: "setpoints?p=10",
			  context: document.body
			});
			
			$("#actualpi").html(actualpi);
			
			setInterval(function() 
			{
				$.getJSON( "getpi", function( data ) 
				{
					if( data != "" )
					{
						pushpi( data );
					}
				});
			}, 1000);
			

		});
	</script>



</body>


<view uri="setpoints" raw="true">

	<server>
		console.dir( GET );
		nsc.set("value", "" );
		nsc.set("points", parseFloat(GET.p) );
		res.end("OK");
	</server>

</view>

<view uri="getpi" raw="true">
	<server>
		res.end(JSON.stringify( nsc.cache.value ));
	</server>
</view>
