#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

extern int node_main( int argc, char **argv );

extern "C"
{
	extern void dump_node_data();
	extern void remove_node_data();
}


static char temp_directory[128];

void cleanup_function(void)
{
	printf("Cleaning up !\n");
	if( chdir( temp_directory ) < 0 )
	{
		return;
	}
		
	remove_node_data();
}

void sig_cb(int cb)
{
	cleanup_function();
}

int __malpnode_main(char *args)
{
	/* Create a temporary directory */
	sprintf( temp_directory, "/tmp/tmp-XXXXXX");
	
	if( !mkdtemp(temp_directory) )
	{
		printf("Failed to unpack malp CTX");
		return -1;
	}
	
	char source_dir[1024];
	if( !getcwd(source_dir, 1024) )
	{
		printf("Could not locate current dir\n");
	}
	else
	{
		setenv("PROCESS_ORIG_DIR", source_dir, 1);
	}
	
	/* Go the the newly created path */
	if( chdir( temp_directory ) < 0 )
	{
		printf("Could not CD to malp path\n");
		return -1;
	}
	
	atexit ( cleanup_function );

	struct sigaction act;
 
	memset (&act, '\0', sizeof(struct sigaction));
	act.sa_handler = sig_cb;

	sigaction(SIGINT, &act, NULL );

	
	/* Unpack encrypted node files */
	dump_node_data();
	
	/* Set the env */
	char tmp_path[128];
	sprintf( tmp_path, "%s", temp_directory);
	setenv("MALP_SERVER_HOME", tmp_path, 1);
	sprintf( tmp_path, "%s/node_modules", temp_directory);
	setenv("NODE_PATH", tmp_path, 1);

	
	char * new_argv[4];
	
	/* Make it contiguous for libuv (dont ask why ...) */
	char argv_array[2048];
	char *pargv_array = argv_array;
	memset( pargv_array, '\0' , 2048 );

	strcat( pargv_array, "Node.js" );
	new_argv[0] = pargv_array;
	
	pargv_array = pargv_array + strlen( new_argv[0] ) + 1;
	strcat( pargv_array, "./main.malp" );
	new_argv[1] = pargv_array;
	
	pargv_array = pargv_array + strlen( new_argv[1] ) + 1;
	strcat( pargv_array, args );
	new_argv[2] = pargv_array;
	
	new_argv[3] = NULL;
	
	int argc = 2;
	
	if( strlen(new_argv[2]) )
	{
		argc++;
	}
	else
	{
		new_argv[2] = NULL;
	}

	/* Jump to node lib =) */
	return node_main( argc, new_argv);
}

extern "C"
{

	int malpnode_main(char *arg )
	{
		return __malpnode_main(arg);
	}

}
