#include "Node_List.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void Node_list_init( struct Node_list ** nl)
{
	if(!nl)
		return;
	
	*nl = NULL;
}


struct Node_list * Node_list_push( struct Node_list * nl, char *addr, int port )
{
	struct Node_list * ret = malloc( sizeof( struct Node_list) );
	
	if( !ret )
	{
		perror("malloc");
		return NULL;
	}
	
	snprintf(ret->addr, 256, "%s", addr );
	ret->port = port;
	ret->associativity = 0;
	ret->next = NULL;
	
	if( nl )
	{
		/* Push at end */
		struct Node_list *tmp = nl;
		while( tmp->next )
		{
			tmp = tmp->next;
		}
		
		tmp->next = ret;
		
		return nl;
	}
	else
	{
		/* Push at begin */
		return ret;
	}
}

int Node_list_pop( struct Node_list ** nl, struct Node_list * dest )
{
	/* Do we have an element ? */
	if( !nl )
		return 0;

	if( !*nl )
	{
		*nl = NULL;
		return 0;
	}
	
	/* Here we return an element twice to build a tree then go to next */
	if( (*nl)->associativity == 2 )
	{
		struct Node_list *to_free = *nl;
		*nl = (*nl)->next;
		free( to_free );
		return Node_list_pop( nl, dest );
	}
	
	
	/* Element present then return it */
	memcpy(dest, *nl, sizeof( struct Node_list ) );
	(*nl)->associativity++;
	
	/* Got an elem */
	return 1;
}


void Node_list_release( struct Node_list ** nl)
{
	struct Node_list elem;
	
	/* Empty the list */
	while( Node_list_pop( nl, &elem ) ){};
}

